## module for writing error in file that produces plots
import numpy as np

def e_plt(dof, h1err, l2err, eta):
  ep = open('e_plt.py','w')
  ep.write ('import matplotlib.pyplot as plt\n\n')
  ## write dof as list
  NN = len(dof) 
  ep.write('dof = [')
  for li in range(1,NN-1):
    print >> ep, dof[li], ',',
  print >> ep, dof[NN-1],
  ep.write(']')

  ## write dof^-1/2 as list
  ep.write('\n\nref = [')
  for li in range(1,NN-1):
    print >> ep, (dof[li])**(-0.5), ',',
  print >> ep, (dof[NN-1])**(-0.5),
  ep.write(']')

  ## write h1err as list
  ep.write('\n\nh1err = [')
  for li in range(1,NN-1):
    print >> ep, h1err[li],',',
  print >> ep, h1err[NN-1],
  ep.write(']')

  ## write l2err as list
  ep.write('\n\nl2err = [')
  for li in range(1,NN-1):
    print >> ep, l2err[li],',',
  print >> ep, l2err[NN-1],
  ep.write(']')

  ## write eta as list
  ep.write('\n\neta = [')
  for li in range(NN-2):
    print >> ep, eta[li],',',
  print >> ep, eta[NN-2],
  ep.write(']')

  ep.write('\n\nst=1\nNN = len(ref) \n')
  ep.write('scale = (l2err[0] + h1err[0])/(2*ref[0])\n')
  ep.write('for j in range(NN):\n\tref[j] = ref[j]*scale\n')
 
  ep.write('dofp = dof[st:NN]\nh1errp = h1err[st:NN]\nl2errp = l2err[st:NN]\n') 
  ep.write('etap = eta[st:NN]\nrefp = ref[st:NN]\n')
  ep.write('\n\n')
  ep.write("plt.loglog(dofp,h1errp,'x-',dofp,l2errp,'o-',dofp,etap,'-p',dofp,refp,'k--')\n")
  ep.write("plt.xlabel('log(dof)')\n")
  ep.write("plt.autoscale(enable='True',axis='x',tight='True')\n")
  ep.write('plt.show()\n')
  ##TODO: choose colors and define legend


## -- ###############################################################################

def eta_plt(dof,eta):
  ep = open('e_plt.py','w')
  ep.write ('import matplotlib.pyplot as plt\n\n')
  ## write dof as list
  NN = len(dof)
  ep.write('dof = [')
  for li in range(1,NN-1):
    print >> ep, dof[li], ',',
  print >> ep, dof[NN-1],
  ep.write(']')

  ## write dof^-1/2 as list
  ep.write('\n\nref = [')
  for li in range(1,NN-1):
    print >> ep, (dof[li])**(-0.5), ',',
  print >> ep, (dof[NN-1])**(-0.5),
  ep.write(']')

  ## write eta as list
  ep.write('\n\neta = [')
  for li in range(NN-2):
    print >> ep, eta[li],',',
  print >> ep, eta[NN-2],
  ep.write(']')
  ep.write('\n\nfig,ax = plt.subplots()\n')
  
  ep.write('\n\nst=5\nNN = len(ref) \n')
  ep.write('scale = (eta[0])/(ref[0])\n')
  ep.write('for j in range(NN):\n\tref[j] = ref[j]*scale\n')

  ep.write('dofp = dof[st:NN]\n')
  ep.write('etap = eta[st:NN]\nrefp = ref[st:NN]\n')
  ep.write('\n\n')
  ep.write("plt.loglog(dofp,etap,'-p',label= '$\eta$')\n")
  ep.write("plt.hold\n")
  ep.write("plt.loglog(dofp,refp,'k--', label = '$n^{-1/2}$')\n")
  ep.write("plt.xlabel('Degrees of freedom, $n$', fontsize=24)\n")
  ep.write("plt.autoscale(enable='True',axis='x',tight='True')\n")
  ep.write("legend = ax.legend()\n\nframe = legend.get_frame()\n")
  ep.write("ax.tick_params(axis='both', which='major', labelsize=18)\n")
  ep.write("ax.tick_params(axis='both', which='minor', labelsize=18),\n")
  ep.write("for label in legend.get_texts():\n  label.set_fontsize(24)\n")
  ep.write("for label in legend.get_lines():\n  label.set_linewidth(1.5)\n")
  ep.write("plt.subplots_adjust(bottom=0.15)\n")
  ep.write('plt.show()\n')
  ##TODO: choose colors and define legend
## -- ###############################################################################

def gammadelta_plt(gamma,beta01,delta):
  ep = open('gd_plt.py','w')
  ep.write ('import matplotlib.pyplot as plt\n\n')
  ## write gamma as list and generate list 0, NN-1
  NN = len(gamma)
  iter = np.arange(NN)
  ep.write('gamma = [')
  for li in range(1,NN-1):
    print >> ep, gamma[li], ',',
  print >> ep, gamma[NN-1],
  ep.write(']')

  ## write beta01 as list
  ep.write('\n\nbeta01 = [')
  for li in range(1,NN-1):
    print >> ep, beta01[li], ',',
  print >> ep, beta01[NN-1],
  ep.write(']')

  ## write delta as list
  ep.write('\n\ndelta = [')
  for li in range(1,NN-1):
    print >> ep, delta[li], ',',
  print >> ep, delta[NN-1],
  ep.write(']')

  ## write iterations list
  ep.write('\n\niter = [')
  for li in range(1,NN-1):
    print >> ep, iter[li], ',',
  print >> ep, iter[NN-1],
  ep.write(']')
  ep.write('\n\nfig,ax = plt.subplots()\n')
  ep.write("plt.semilogy(iter,gamma,'-p',label='$\\gamma_{10}$')\nplt.hold\n")
  ep.write("plt.semilogy(iter,beta01,'x-', label='$\\gamma_{01}$')\n")
  ep.write("plt.semilogy(iter,delta,'x-', label='$\delta$')\n")
  ep.write("plt.xlabel('Refinements', fontsize=24)\n")
  ep.write("plt.autoscale(enable='True',axis='x',tight='True')\n")
  ep.write("legend = ax.legend()\n\nframe = legend.get_frame()\n")
  ep.write("ax.tick_params(axis='both', which='major', labelsize=18)\n")
  ep.write("ax.tick_params(axis='both', which='minor', labelsize=18),\n")
  ep.write("for label in legend.get_texts():\n  label.set_fontsize(24)\n")
  ep.write("for label in legend.get_lines():\n  label.set_linewidth(1.5)\n")
  ep.write("plt.subplots_adjust(bottom=0.15)\n")
  ep.write('plt.show()\n')
  ##TODO: choose colors 
  ## DONE: defined legend

## -- ###############################################################################
def alphares_plt(alpha,aRw,res):
  ep = open('alphaRes_plt.py','w')
  ep.write ('import matplotlib.pyplot as plt\n\n')
  ## write alpha as list and generate list 0, NN-1
  NN = len(alpha)
  iter = np.arange(NN)
  
  ## write alpha as list
  ep.write('alpha = [')
  for li in range(1,NN-1):
    print >> ep, alpha[li], ',',
  print >> ep, alpha[NN-1],
  ep.write(']')

  ## write aRw as list
  ep.write('\n\naRw = [')
  for li in range(1,NN-1):
    print >> ep, aRw[li], ',',
  print >> ep, aRw[NN-1],
  ep.write(']')
  
  ## write res as list
  ep.write('\n\nres = [')
  for li in range(1,NN-1):
    print >> ep, res[li], ',',
  print >> ep, res[NN-1],
  ep.write(']')

  ## write iterations list
  ep.write('\n\niter = [')
  for li in range(1,NN-1):
    print >> ep, iter[li], ',',
  print >> ep, iter[NN-1],
  ep.write(']')
  ep.write('\n\nfig,ax = plt.subplots()\n')
  ep.write("plt.semilogy(iter,alpha,'-p',label='$\ \\alpha$')\nplt.hold\n")
  ep.write("plt.semilogy(iter,aRw,'-p',label='$\ \\alpha\|Rw\|$')\nplt.hold\n")
  ep.write("plt.semilogy(iter,res,'x-', label='$\|r_k\|$')\n")
  ep.write("plt.xlabel('Refinements', fontsize=24)\n")
  ep.write("plt.autoscale(enable='True',axis='x',tight='True')\n")
  ep.write("legend = ax.legend()\n\nframe = legend.get_frame()\n")
  ep.write("ax.tick_params(axis='both', which='major', labelsize=18)\n")
  ep.write("ax.tick_params(axis='both', which='minor', labelsize=18),\n")
  ep.write("for label in legend.get_texts():\n  label.set_fontsize(24)\n")
  ep.write("for label in legend.get_lines():\n  label.set_linewidth(1.5)\n")
  ep.write("plt.subplots_adjust(bottom=0.15)\n")
  ep.write('plt.show()\n')
  ##TODO: choose colors 
  ## DONE: defined legend

## -- ###############################################################################
def swork_plt(swork,Cswork):
  ep = open('swork_plt.py','w')
  ep.write ('import matplotlib.pyplot as plt\n\n')
  ## write gamma as list and generate list 0, NN-1
  NN = len(swork)
  iter = np.arange(NN)
  ep.write('swork = [')
  for li in range(1,NN-1):
    print >> ep, swork[li], ',',
  print >> ep, swork[NN-1],
  ep.write(']')

  ## write beta01 as list
  ep.write('\n\nCswork = [')
  for li in range(1,NN-1):
    print >> ep, Cswork[li], ',',
  print >> ep, Cswork[NN-1],
  ep.write(']')

  ## write iterations list
  ep.write('\n\niter = [')
  for li in range(1,NN-1):
    print >> ep, iter[li], ',',
  print >> ep, iter[NN-1],
  ep.write(']')
  ep.write('\n\nfig,ax = plt.subplots()\n')
  ep.write("plt.semilogy(iter,swork,'-p',label='solve work')\nplt.hold\n")
  ep.write("plt.semilogy(iter,Cswork,'x-', label='Cum. solve work')\n")
  ep.write("plt.xlabel('Refinements', fontsize=24)\n")
  ep.write("plt.autoscale(enable='True',axis='x',tight='True')\n")
  ep.write("legend = ax.legend()\n\nframe = legend.get_frame()\n")
  ep.write("ax.tick_params(axis='both', which='major', labelsize=18)\n")
  ep.write("ax.tick_params(axis='both', which='minor', labelsize=18),\n")
  ep.write("for label in legend.get_texts():\n  label.set_fontsize(24)\n")
  ep.write("for label in legend.get_lines():\n  label.set_linewidth(1.5)\n")
  ep.write("plt.subplots_adjust(bottom=0.15)\n")
  ep.write('plt.show()\n')


## -- ###############################################################################
#def save_soln_pdf(mesh, cells, u, umin, umax, titlestr):
def save_soln_pdf(mesh, cells, u, titlestr,bpad):
  ## incoming
  ## use save_solnmm_pdf to send in umin, umax

  import matplotlib.pyplot as plt
  import matplotlib.tri as tri
  from mpl_toolkits.mplot3d import Axes3D
  #from mpl_toolkits.axes_grid1 import make_axes_locatable
  from matplotlib import cm

  # define coordinates from mesh geometry
  nn = mesh.num_vertices()
  dd = mesh.geometry().dim()

  # Create the triangulation
  mesh_coordinates = mesh.coordinates().reshape((nn, dd))
  triangles = np.asarray([cell.entities(0) for cell in cells(mesh)]) 
  triangulation = tri.Triangulation(mesh_coordinates[:, 0],
                                    mesh_coordinates[:, 1],
                                    triangles)

  # Get the z values as face colors for each triangle(midpoint)
  #zfaces = np.asarray([u(cell.midpoint()) for cell in cells(mesh)])
  # Get the z values for each vertex
  z = np.asarray([u(point) for point in mesh_coordinates])
  
  fig = plt.figure()
  ax = fig.gca(projection='3d')
  
  new_map = adjust_cmap(cm)
  
  #ax.plot_trisurf(triangulation, z, cmap=cm.gist_stern, linewidth=0.1)
  # -- below sets the plot limits
  #im = ax.plot_trisurf(triangulation, z, cmap = new_map,linewidth=0.1,vmin=-0.0,vmax=2.0)
  im = ax.plot_trisurf(triangulation, z, cmap = new_map,linewidth=0.1)

  ax.set_axis_off()  ##ax.set_axis_on() turns it on
  ax.frameon=False
  
  #plt.box(off)
  #ax.set_axis_bgcolor('w')
  #ax.set_xlabel('X')
  #ax.set_ylabel('Y')
  #ax.set_zlabel('Z')
  #ax.set_xlim(-40, 40)
  #ax.set_ylim(-40, 40)
  ax.spines['right'].set_visible(True)
  #ax.set_zlim(umin, umax)
  # -- new!  a colorbar! ## pad is vertical pad b/w bar and pic
  #cbar=plt.colorbar(im,orientation='horizontal',fraction=0.075,shrink=0.65,pad=-0.1,\
  # ticks=[0,2,4,6,8,10],extendfrac=20)
  #cbar=plt.colorbar(im,orientation='horizontal',fraction=0.075,shrink=0.65,pad=-0.0,\
  #cbar=plt.colorbar(im,orientation='horizontal',fraction=0.075,shrink=0.65,pad=bpad,\
  # extendfrac=20)
  cbar=plt.colorbar(im,orientation='horizontal',fraction=0.075,shrink=0.65,pad=bpad,\
   extendfrac='auto')

  plt.savefig(titlestr)
  plt.close()


def save_solnmm_pdf(mesh, cells, u, umin, umax, titlestr,bpad):
  ## umin, umax are numbers sent in so multiple plots can have same scale

  import matplotlib.pyplot as plt
  import matplotlib.tri as tri
  from mpl_toolkits.mplot3d import Axes3D
  #from mpl_toolkits.axes_grid1 import make_axes_locatable
  from matplotlib import cm

  # define coordinates from mesh geometry
  nn = mesh.num_vertices()
  dd = mesh.geometry().dim()

  # Create the triangulation
  mesh_coordinates = mesh.coordinates().reshape((nn, dd))
  triangles = np.asarray([cell.entities(0) for cell in cells(mesh)]) 
  triangulation = tri.Triangulation(mesh_coordinates[:, 0],
                                    mesh_coordinates[:, 1],
                                    triangles)

  # Get the z values for each vertex
  z = np.asarray([u(point) for point in mesh_coordinates])
  
  fig = plt.figure()
  ax = fig.gca(projection='3d')
  
  new_map = adjust_cmap(cm)
  
  # -- below sets the plot limits
  im = ax.plot_trisurf(triangulation, z, cmap = new_map,linewidth=0.1,vmin=umin,vmax=umax)
  #im = ax.plot_trisurf(triangulation, z, cmap = new_map,linewidth=0.1)

  ax.set_axis_off()  ##ax.set_axis_on() turns it on
  ax.frameon=False
  
  ax.spines['right'].set_visible(True)
  ax.set_zlim(umin, umax)
  cbar=plt.colorbar(im,orientation='horizontal',fraction=0.075,shrink=0.65,pad=bpad,\
   extendfrac='auto')

  plt.savefig(titlestr)
  plt.close()

#def save_soln_mesh(mesh, cells, u, umin, umax, titlestr):
#def save_soln_mesh(mesh, cells, u, titlestr):
def save_mesh(mesh, cells, titlestr):
  ## incoming
  ## umin, umax are numbers sent in so multiple plots can have same scale
  import matplotlib.pyplot as plt
  import matplotlib.tri as tri
  from mpl_toolkits.mplot3d import Axes3D
  from matplotlib import cm
  from matplotlib import colors
  
  # define coordinates from mesh geometry
  nn = mesh.num_vertices()
  dd = mesh.geometry().dim()
  
  # Create the triangulation
  mesh_coordinates = mesh.coordinates().reshape((nn, dd))
  triangles = np.asarray([cell.entities(0) for cell in cells(mesh)])
  triangulation = tri.Triangulation(mesh_coordinates[:, 0],
                                    mesh_coordinates[:, 1],
                                    triangles)
    
  # Get the z values as face colors for each triangle(midpoint)
  #z = np.asarray([u(point) for point in mesh_coordinates])
  #z = np.asarray([u(cell.midpoint()) for cell in cells(mesh)])
  #z = np.asarray([u(point) for point in mesh_coordinates])
  fig=plt.figure()
  ax = fig.gca()
  #new_map = adjust_cmap(cm)
  ## 2d plot with color indicating value
  #plt.tripcolor(triangulation, z, edgecolors='k',cmap=cm.gist_stern)
  # attempting to use vmin, vmax to freeze the colorscale
  #plt.tripcolor(triangulation, z, edgecolors='k',cmap=new_map,vmin=-0.3, vmax=0.6, norm=norm)
  #plt.tripcolor(triangulation, z, edgecolors='k',cmap=new_map,norm=norm)
  ## just a mesh, no coloring
  plt.triplot(triangulation, 'k-')
  ax.set_axis_off()  ##ax.set_axis_on() turns it on
  ax.frameon=False
  #plt.setnorm(norm)
  ax.autoscale=False
  #ax.setnorm(norm)
  
  ## make a square a square
  ax.set_aspect('equal')
  ## nice edges: not too fancy:)
  ## if domain is wrong, fix it HERE!!
  #ax.axhline(y=0,linewidth=4,color="darkslateblue") ## midnightblue is also nice
  #ax.axhline(y=1,linewidth=4,color="darkslateblue") ##(y=1,xmin=a,ymin=b,
  #ax.axvline(x=0,linewidth=4,color="darkslateblue") ##     line2Dproperties="")
  #ax.axvline(x=1,linewidth=4,color="darkslateblue")
  plt.savefig(titlestr)
  plt.close()

def adjust_cmap(cm):
  # -- option 1
  #ncmap = cm.get_cmap(cm.PuBuGn)
  #colors = ncmap(np.arange(ncmap.N))
  #alpha = 0.5
  #colors = 2*abs(0.5-colors)
  #colors = (colors + alpha)/(1.0+alpha)
  
  # -- option 2 
  #ncmap = cm.get_cmap(cm.PuBu)
  #colors = ncmap(np.arange(ncmap.N))
  #alpha = 0.25
  #colors = 2*abs(0.5-colors)
  #colors = (colors + alpha)/(1.0+alpha)

  # -- option 3 
  ncmap = cm.get_cmap(cm.coolwarm)
  colors = ncmap(np.arange(ncmap.N))
  alpha = 0.25
  colors = 2.0*abs(0.5-colors)
  #colors = (colors + alpha)/(1.0+alpha)

#colors = colors - alpha*(1.0-colors)
  new_map = ncmap.from_list("gnuplot_calm", colors, ncmap.N)
  return(new_map)


